package cn.com.infosec.asn1.cms;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DEREncodable;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERObjectIdentifier;
import cn.com.infosec.asn1.DERSequence;

public class OtherRecipientInfo extends ASN1Encodable {
   private DERObjectIdentifier oriType;
   private DEREncodable oriValue;

   public OtherRecipientInfo(DERObjectIdentifier oriType, DEREncodable oriValue) {
      this.oriType = oriType;
      this.oriValue = oriValue;
   }

   public OtherRecipientInfo(ASN1Sequence seq) {
      this.oriType = DERObjectIdentifier.getInstance(seq.getObjectAt(0));
      this.oriValue = seq.getObjectAt(1);
   }

   public static OtherRecipientInfo getInstance(ASN1TaggedObject obj, boolean explicit) {
      return getInstance(ASN1Sequence.getInstance(obj, explicit));
   }

   public static OtherRecipientInfo getInstance(Object obj) {
      if (obj != null && !(obj instanceof OtherRecipientInfo)) {
         if (obj instanceof ASN1Sequence) {
            return new OtherRecipientInfo((ASN1Sequence)obj);
         } else {
            throw new IllegalArgumentException("Invalid OtherRecipientInfo: " + obj.getClass().getName());
         }
      } else {
         return (OtherRecipientInfo)obj;
      }
   }

   public DERObjectIdentifier getType() {
      return this.oriType;
   }

   public DEREncodable getValue() {
      return this.oriValue;
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10000 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var1.add(this.oriType);
      var10000.add(this.oriValue);
      return new DERSequence(var1);
   }
}
